var theater =document.querySelector(".theater");
var game=new Environment3d(theater);
	
////////////////////////////////////
//Générer les murs du labyrinthe ://
////////////////////////////////////
var texture_mur=new Texture({'url' : 'images/wall_512_5_05.jpg', 'background-repeat':'repeat'})
var textures_laby={'left':texture_mur, 'right':texture_mur, 'front':texture_mur, 'back':texture_mur}
//cellules générées en Python :
var cellules=[[{'E': true, 'N': true, 'S': false, 'W': false},
  {'E': true, 'N': false, 'S': true, 'W': true},
  {'E': true, 'N': false, 'S': true, 'W': true},
  {'E': true, 'N': false, 'S': false, 'W': true},
  {'E': false, 'N': false, 'S': true, 'W': true}],
 [{'E': true, 'N': false, 'S': true, 'W': false},
  {'E': true, 'N': true, 'S': true, 'W': true},
  {'E': false, 'N': true, 'S': false, 'W': true},
  {'E': true, 'N': false, 'S': false, 'W': false},
  {'E': false, 'N': true, 'S': true, 'W': true}],
 [{'E': false, 'N': true, 'S': true, 'W': false},
  {'E': true, 'N': true, 'S': false, 'W': false},
  {'E': true, 'N': false, 'S': false, 'W': true},
  {'E': true, 'N': false, 'S': true, 'W': true},
  {'E': false, 'N': true, 'S': false, 'W': true}],
 [{'E': true, 'N': true, 'S': true, 'W': false},
  {'E': false, 'N': false, 'S': true, 'W': true},
  {'E': false, 'N': false, 'S': true, 'W': false},
  {'E': true, 'N': true, 'S': false, 'W': false},
  {'E': false, 'N': false, 'S': true, 'W': true}],
 [{'E': false, 'N': true, 'S': false, 'W': false},
  {'E': true, 'N': true, 'S': false, 'W': false},
  {'E': true, 'N': true, 'S': false, 'W': true},
  {'E': false, 'N': false, 'S': false, 'W': true},
  {'E': false, 'N': true, 'S': true, 'W': false}]]
//chemin trouvé en python
var chemin=[[4, 4], [3, 4], [3, 3], [2, 3], [2, 2], [2, 1], [1, 1], [0, 1], [0, 0]]


/*
*/

var w_cell=350 //largeur cellule
var h_mur=300 //hauteur mur
var d_cell=350 // profondeur cellule
var ep_mur=30 // épaisseur des murs
//point d'origine (coin sud ouest)
var x0_laby=w_cell+ep_mur
var y0_laby=0
var z0_laby=d_cell+ep_mur

var x,y,z,w,h,d,e,cell//alias
var mur=null
var n=cellules.length;
var m=cellules[0].length;
x=x0_laby;y=y0_laby;z=z0_laby;w=w_cell;h=h_mur;d=d_cell;e=ep_mur;

for(var i=cellules.length-1;i>=0;i--){
	for(var j=0;j<cellules[i].length;j++){
		cell = cellules[i][j]
		for(var dir in cell){
			if(cell[dir]){continue;}
			switch(dir){	
				case "W":
					mur=new Box(x + j*w, y , z + (n-i-1)*d, e, h, d, textures_laby)
				break
				case "E":
					if(j==cellules[i].length-1){
						mur=new Box(x + (j+1)*w, y, z + (n-i-1)*d, e, h, d, textures_laby)
					}
				break
				case "S":
					mur=new Box(x + j*w, y, z + (n-i-1)*d, w, h, e, textures_laby)
				break
				case "N":
					if(i==0){
						mur=new Box(x + j*w, y , z+ (n-i)*d, w, h, e, textures_laby)
					}
				break
				case "bottom":
					mur=new Box(x + j*w, y , z+ (n-i-1)*d, w, e, d, textures_laby)
				break
				case "up":
					mur=new Box(x + j*w, y , z+ (n-i-1)*d, w, e, d, textures_laby)
				break
			}
			if(mur){
				game.addObject(mur)
			}			
			mur=null
		}
	}
}

//variables sprite chemin
var largeur_feu=128
var hauteur_feu=128
var largeur_img_feu=128
var hauteur_img_feu=128
var colonnes_feu=8
var lignes_feu=4
var dt=40
var feu
chemin.push([5,4])
chemin.push([5,2])
chemin.push([-1,0])
for(var k=0;k<chemin.length;k++){
	var i=chemin[k][0]
	var j=chemin[k][1]
	feu=new Sprite(x + (j+0.3)*w, 0 ,z + (n-i-0.5)*d, largeur_feu, hauteur_feu, "images/magie.png", largeur_img_feu, hauteur_img_feu, dt, colonnes_feu, lignes_feu)
	game.addObject(feu)
}

var w=(n+2)*w_cell + 2*ep_mur
var h=(m+2)*d_cell + 2*ep_mur

var w_sol=(n+4)*w_cell + 2*ep_mur
var h_sol=(m+4)*d_cell + 2*ep_mur


var x0_sol=-w_cell
var y0_sol=0
var z0_sol=-d_cell

//ajout d'un rectangle avec une texture pour le sol : 
var texture_sol=new Texture({'url' : 'images/sol-pavé2.jpg', 'background-repeat':'repeat'});
var sol=new Rectangle(x0_sol,y0_sol,z0_sol,w_sol,h_sol,texture_sol)
sol.setTransformOrigin('left','bottom')
sol.move(x0_sol,y0_sol,z0_sol,-90,0,0)

//perso fps
var x_perso=3*w_cell/2
var y_perso=0
var z_perso=d_cell/2
var h_perso=200
var perso=new Perso(x_perso,y_perso,z_perso, h_perso)

//skybox par défaut
var skybox=new Skybox();

game.addObject(skybox)
game.addObject(sol)
game.addObject(perso)
perso.activate()


/////////////////////////////////
//       facultatif            //
/////////////////////////////////

//grillage autour:
var texture_grillage=new Texture({'url' : 'images/grillage.png', 'background-repeat':'repeat','background-size':'50px 50px'});
var grillage_front=new Rectangle(0,0,0,w,h_mur,texture_grillage)

var grillage_left=new Rectangle(0,0,0,w,h_mur,texture_grillage)
grillage_left.setTransformOrigin('left','bottom')
grillage_left.move(0,0,0,0,90,0)

var grillage_right=new Rectangle(0,0,0,w,h_mur,texture_grillage)
grillage_right.setTransformOrigin('right','bottom')
grillage_right.move(0,0,0,0,-90,0)

var grillage_back=new Rectangle(0,0,h,w,h_mur,texture_grillage)

var grillage_stop1=new Rectangle(0,0,3*(d_cell),w_cell+ep_mur,h_mur,texture_grillage)
var grillage_stop2=new Rectangle(w-w_cell,0,3*(d_cell),w_cell,h_mur,texture_grillage)
var grillage_stop3=new Rectangle(w-w_cell,0,h - 3*(d_cell),w_cell,h_mur,texture_grillage)

game.addObject(grillage_front)
game.addObject(grillage_left)
game.addObject(grillage_right)
game.addObject(grillage_back)
game.addObject(grillage_stop1)
game.addObject(grillage_stop2)
game.addObject(grillage_stop3)

//murs autours : 
var mur_front=new Rectangle(-w_cell,0,-d_cell,w_sol,0.8*h_mur,texture_mur)
var mur_left=new Rectangle(0,0,0,w_sol,0.8*h_mur,texture_mur)
mur_left.setTransformOrigin('left','bottom')
mur_left.move(-w_cell,0,-d_cell,0,90,0)

var mur_right=new Rectangle(0,0,0,w_sol,0.8*h_mur,texture_mur)
mur_right.setTransformOrigin('right','bottom')
mur_right.move(-w_cell,0,-d_cell,0,-90,0)
var mur_back=new Rectangle(-w_cell,0,h_sol-w_cell,w_sol,0.8*h_mur,texture_mur)

game.addObject(mur_front)
game.addObject(mur_left)
game.addObject(mur_right)
game.addObject(mur_back)

//cube arrivée :
var x_cube1=2*w_cell
var y_cube1=0
var z_cube1=h - w_cell/2;
var hauteur_cube1=120;
var norman_cube=new Cube(x_cube1,y_cube1,z_cube1, hauteur_cube1, "images/Norman_Cube.png")

game.addObject(norman_cube)

//cake : 
var largeur_cake = 125
var hauteur_cake = 140
var x_cake = x_cube1
var y_cake = hauteur_cube1
var z_cake = z_cube1 + (hauteur_cube1)/2

var cake=new Sprite(x_cake,y_cake,z_cake, largeur_cake, hauteur_cake, "images/cake.png")
game.addObject(cake)

//chest : 
//cube arrivée :
var x_chest=w - 0.8*w_cell
var y_chest=0
var z_chest=3.5*d_cell;
// var z_chest=0;


var hauteur_chest=120;
var largeur_chest=200;
var profondeur_chest=120;
var tx_chest_top=new Texture("images/chest-top.jpg")
var tx_chest_lr=new Texture("images/chest-left-right.jpg")
var tx_chest_fb=new Texture("images/chest-front-back.jpg")

var chest=new Box(x_chest,y_chest,z_chest, largeur_chest, hauteur_chest, profondeur_chest, {'top':tx_chest_top, 'left':tx_chest_lr,'right':tx_chest_lr, 'front':tx_chest_fb, 'back':tx_chest_fb, 'bottom':false})
chest.move(x_chest,y_chest,z_chest,0,33,0)
game.addObject(chest)
